#ifndef compression_h
#define compression_h

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "functions.h"
#include "functions_sse.h"
#include "huffman.h"
#include "list.h"

//includes para opencv
#include <cv.h>
#include "highgui.h"

void compress_image(FILE * image_in, int thresh, int assembler);
void jpeg_from_webcam (int thresh, int assembler);
int compress_AVI (char* name_video_in, int thresh, int assembler);
void compress_frame (int **i_matrix, int w, int h, FILE* header_out, FILE * video_out);
void compress_buffer_file (int ** i_matrix, int width, int high, nodo_lista_c * lista, int long_codificado, FILE* buffer);

#endif
