#ifndef functions_h
#define functions_h

//includes para opencv
#include <cv.h>
#include "highgui.h"

void coseno();
//~ void reduce_image(int ** i_matrix, int WIDTH, int HIGH);


//funciones para la compresion jpge
void read_image_ipl (IplImage * image_in, int **m);
void read_image (FILE * image_in, int **m, int width, int high, int begin, int size);
void write_image_ipl (IplImage * image_in, int **m);
void write_image (FILE * image_out, int **m, int width, int high, int begin, int size);
void jpeg(int ** i_matrix, int width, int high, int thresh);
void substract_128 (int ** i_matrix, int width, int high);
int sumatoria (int ** i_matrix, int k, int row, int col);
void dct2 (int** imagen, int i, int j);
void print_matrix (int ** i_matrix, int width, int high);
void divide_by_blocks_and_dct (int ** i_matrix, int width, int high);
void quantization (int ** i_matrix, int row_b, int col_b);
void divide_by_blocks_and_quant (int ** i_matrix, int width, int high);
void threshold (int ** i_matrix, int width, int high, int threshold);


//Funciones para la descomprecion JPEG
void jpeg_dec(int ** i_matrix, int width, int high);
void idct2 (int** imagen, int i, int j);
void mult_quantization(int ** i_matrix, int row_b, int col_b);
void add_128 (int ** i_matrix, int width, int high);
void divide_by_blocks_and_m_quant(int ** i_matrix, int width, int high);
void divide_by_blocks_and_idct(int ** i_matrix, int width, int high);

#endif
