#include <stdio.h>
#include <stdlib.h>
#include "list.h"

#define TAM_STR_A sizeof(nodo_arbol_t)
#define TAM_STR_L_A sizeof(nodo_lista_ab)
#define TAM_STR_L_C sizeof(nodo_lista_c)

/**############# CODIGO ################*/
//~ codigo_t * crear_codigo(unsigned int simbolo)
//~ {
	//~ codigo_t * cod = malloc (TAM_STR_C);
	//~ cod->caracter = simbolo;
	//~ cod->codigo = -1;
	//~ cod->long_cod = -1;
	//~ 
	//~ return cod;
//~ }
 

/**############# LISTA AB ################*/
nodo_lista_ab * crear_nodo_lista_ab_default()
{
	nodo_lista_ab * nodo_lista;
	nodo_lista = malloc(TAM_STR_L_A);
	nodo_arbol_t * nodo_ab = NULL;
	nodo_lista->sig = NULL;
	
	return nodo_lista;
}

nodo_lista_ab * crear_nodo_lista_ab(nodo_arbol_t * nodo_ab, nodo_lista_ab * sig)
{
	nodo_lista_ab * nodo_lista;
	nodo_lista = malloc(TAM_STR_L_A);
	nodo_lista->nodo_arbol = nodo_ab;
	nodo_lista->sig = sig;
	
	return nodo_lista;	
}

//si esta devuelve el puntero al nodo anterior, si no esta NULL
nodo_lista_ab * buscar_simbolo_ab (nodo_lista_ab * lista, int simbolo, int * posicion)
{
	//~ printf("simbolo: %i\n",simbolo);
	nodo_lista_ab * nodo_actual = lista;
	nodo_lista_ab * nodo_anterior = NULL;
	int i = -1;

	if (lista != NULL)
	{
		i = 0;

		while (nodo_actual->nodo_arbol->simbolo != simbolo)
		{
			//~ mostrar_lista_ab(lista);
			//~ printf("long lista: %i\n",long_lista_ab(lista));
			nodo_anterior = nodo_actual;
			nodo_actual = nodo_actual->sig;
			i++;
			
			if (nodo_actual == NULL) //La lista no esta vacia pero no esta el elemento
			{
				nodo_anterior = NULL;
				i = -1;
				break;
			}
		}
	}

	//~ (nodo_actual == NULL) ? printf("No esta el simbolo %i\n", simbolo) : printf("El simbolo %i es en la posicion %i\n", simbolo, i);
	
	//~ mostrar_lista_ab (lista);
	//~ printf("i: %i\n", i);
	*posicion = i;
	//~ printf("Vuelvo\n");
	return nodo_anterior;
}

nodo_lista_ab * insertar_ordenado_ab (nodo_lista_ab * lista, nodo_arbol_t * nodo_arbol_n)
{
	//~ printf("Insertando nodo\n");
	nodo_lista_ab * nodo_aux;
	nodo_lista_ab * nodo_ant;
	nodo_aux = lista;
	nodo_ant = lista;
	if (lista == NULL)
	{
		lista = malloc(TAM_STR_L_A);
		lista->nodo_arbol = nodo_arbol_n;
		lista->sig = NULL;
	}else{
		nodo_lista_ab * nodo_nuevo;
		nodo_nuevo = malloc(TAM_STR_L_A);
		nodo_nuevo->nodo_arbol = nodo_arbol_n;
		nodo_nuevo->sig = NULL;
		if(lista->nodo_arbol->apariciones > nodo_arbol_n->apariciones || lista->nodo_arbol->apariciones == nodo_arbol_n->apariciones)
			{
				//hay que insertar en el primero
				nodo_nuevo->sig = lista;
				lista = nodo_nuevo;
			}else{
				while(nodo_aux->nodo_arbol->apariciones < nodo_arbol_n->apariciones && nodo_aux->sig != NULL)
				{
					//mientras las apariciones son mayores avanzo el puntero
					nodo_ant = nodo_aux;
					nodo_aux = nodo_aux->sig;
				}
				if (nodo_aux->sig == NULL)
				{
					if(nodo_aux->nodo_arbol->apariciones > nodo_arbol_n->apariciones)
					{
						nodo_ant->sig = nodo_nuevo;
						nodo_nuevo->sig = nodo_aux;
					}else{
						//llegue al ultimo
						nodo_aux->sig = nodo_nuevo;
					}
				}else{
					//estoy en el medio
					nodo_ant->sig = nodo_nuevo;
					nodo_nuevo->sig = nodo_aux;
				}
		}
	}
	return lista;
}

void mostrar_lista_ab ( nodo_lista_ab *l )
{	
	nodo_lista_ab * nodo_aux = l;
	printf("Lista ab: <");

	while (nodo_aux != NULL)
	{
		printf ( "%d ", nodo_aux->nodo_arbol->simbolo );      
		printf ( "(%d)	", nodo_aux->nodo_arbol->apariciones );
		nodo_aux = nodo_aux->sig;
	}
	printf(">\n");
}

int long_lista_ab (nodo_lista_ab * lista)
{
	nodo_lista_ab * nodo_aux;
	nodo_aux = lista;
	int i = 0;
	
	while (nodo_aux != NULL)
	{
		i++;
		nodo_aux = nodo_aux->sig;
	}
	
	return i;
}

int eliminar_lista_ab ( nodo_lista_ab * l )
{
	nodo_lista_ab * nodo_actual = l;
	nodo_lista_ab * nodo_siguiente;
	int long_l = long_lista_ab(l);
	int cant_elim = 0;

	while (nodo_actual != NULL) {
		nodo_siguiente = nodo_actual->sig;
		free(nodo_actual);
		nodo_actual = nodo_siguiente;
		cant_elim++;
	}

	if (cant_elim == long_l) return 0;
	else return 1;
}


/**############# LISTA CODIGOS ################*/

nodo_lista_c * crear_nodo_lista_default()
{
	nodo_lista_c * nodo_lista;
	nodo_lista = malloc(TAM_STR_L_C);
	nodo_arbol_t * nodo_ab = NULL;
	nodo_lista->nodo_arbol = nodo_ab;
	nodo_lista->codigo = 0;
	nodo_lista->long_cod = 0;
	nodo_lista->caracter = -1;
	nodo_lista->sig = NULL;
	
	return nodo_lista;
}

nodo_lista_c * crear_nodo_lista(nodo_arbol_t * nodo_ab, unsigned int simbolo, nodo_lista_c * sig)
{
	nodo_lista_c * nodo_lista;
	nodo_lista = malloc(TAM_STR_L_C);
	nodo_lista->nodo_arbol = nodo_ab;
	nodo_lista->codigo = 0;
	nodo_lista->caracter = simbolo;
	nodo_lista->long_cod = 0;
	nodo_lista->sig = sig;
	
	return nodo_lista;	
}

//si esta, devuelve el puntero al nodo anterior, si no esta NULL
nodo_lista_c * buscar_simbolo (nodo_lista_c * lista, unsigned int simbolo, nodo_lista_c * nodo_ant)
{
	nodo_lista_c * nodo_actual = lista;
	nodo_lista_c * nodo_anterior = NULL;

	if (nodo_actual != NULL)
	{
		while (nodo_actual->caracter != simbolo)
		{
			nodo_anterior = nodo_actual;
			nodo_actual = nodo_actual->sig;
			
			if (nodo_actual == NULL)
			{
				nodo_anterior = NULL;
				break;
			}
		}
	}
	
	nodo_ant = nodo_anterior;
	return nodo_actual;
}

void mostrar_codigos (nodo_lista_c * lista){
	printf("\nMostrar codigos\n");
	nodo_lista_c * nodo_aux = lista;
	while (nodo_aux != NULL)
	{
		printf("Simbolo: %i		%08X  ", nodo_aux->caracter, nodo_aux->caracter);
		printf("Codigo: %08X = %i	", nodo_aux->codigo, nodo_aux->codigo);
		printf("Longitud: %i	%08X\n", nodo_aux->long_cod, nodo_aux->long_cod);
		nodo_aux = nodo_aux->sig;
	}
	printf("Fin lista codigos\n");
}

unsigned int long_lista_codigos (nodo_lista_c * lista)
{
	nodo_lista_c * nodo_aux;
	nodo_aux = lista;
	unsigned int i = 0;
	
	while (nodo_aux != NULL)
	{
		i++;
		nodo_aux = nodo_aux->sig;
	}
	
	return i;
}

int eliminar_lista ( nodo_lista_c * l )
{
	nodo_lista_c * nodo_actual = l;
	nodo_lista_c * nodo_siguiente;
	int long_l = long_lista_codigos(l);
	int cant_elim = 0;

	while (nodo_actual != NULL) {
		nodo_siguiente = nodo_actual->sig;
		free(nodo_actual);
		nodo_actual = nodo_siguiente;
		cant_elim++;
	}

	if (cant_elim == long_l) return 0;
	else return 1;
}


//~ nodo_lista_t * insertar_ordenado(nodo_lista_t * tabla_codigos, nodo_arbol_t * nodo_arbol_n, codigo_t * cod)
//~ {
	//~ nodo_lista_t * nodo_aux;
	//~ nodo_lista_t * nodo_ant;
	//~ nodo_aux = tabla_codigos;
	//~ nodo_ant = tabla_codigos;
	//~ if (tabla_codigos == NULL)
	//~ {
		//~ tabla_codigos = malloc(TAM_STR_L);
		//~ tabla_codigos->nodo_arbol = nodo_arbol_n;
		//~ tabla_codigos->cod = cod;
		//~ tabla_codigos->sig = NULL;
	//~ }else{
		//~ nodo_lista_t * nodo_nuevo;
		//~ nodo_nuevo = malloc(TAM_STR_L);
		//~ nodo_nuevo->nodo_arbol = nodo_arbol_n;
		//~ nodo_nuevo->cod = cod;
		//~ nodo_nuevo->sig = NULL;
		//~ if(tabla_codigos->nodo_arbol->apariciones > nodo_arbol_n->apariciones || tabla_codigos->nodo_arbol->apariciones == nodo_arbol_n->apariciones)
			//~ {
				//~ //hay que insertar en el primero
				//~ nodo_nuevo->sig = tabla_codigos;
				//~ tabla_codigos = nodo_nuevo;
			//~ }else{
				//~ while(nodo_aux->nodo_arbol->apariciones < nodo_arbol_n->apariciones && nodo_aux->sig != NULL)
				//~ {
					//~ //mientras las apariciones son mayores avanzo el puntero
					//~ nodo_ant = nodo_aux;
					//~ nodo_aux = nodo_aux->sig;
				//~ }
				//~ if (nodo_aux->sig == NULL)
				//~ {
					//~ if(nodo_aux->nodo_arbol->apariciones > nodo_arbol_n->apariciones)
					//~ {
						//~ nodo_ant->sig = nodo_nuevo;
						//~ nodo_nuevo->sig = nodo_aux;
					//~ }else{
						//~ //llegue al ultimo
						//~ nodo_aux->sig = nodo_nuevo;
					//~ }
				//~ }else{
					//~ //estoy en el medio
					//~ nodo_ant->sig = nodo_nuevo;
					//~ nodo_nuevo->sig = nodo_aux;
				//~ }
		//~ }
	//~ }
	//~ return tabla_codigos;
//~ }




//~ void mostrarListaAuxAB ( nodo_lista_ab *l )
//~ {
        //~ if(l == NULL)
        //~ {
			//~ printf("llegue a null\n");
        //~ }else {
			//~ printf ( "Simbolo: %d =	", l->nodo_arbol->simbolo );      
			//~ printf ( "%c	", l->nodo_arbol->simbolo );
			//~ printf ( "Apariciones: %d\n", l->nodo_arbol->apariciones );
			//~ mostrarListaAux ( l->sig);
        //~ }
//~ }
