; dct2 = sum{k=0 a 7}(x_{i,k} * cos (pi/8 * i * (k + 1/2)))

BITS 32

%define temp [ebp + 8]
%define i [ebp + 12]
%define j [ebp + 16]
%define width [ebp + 20]		; el ancho vendra expresado en bytes.
%define temp2 [ebp + 24] ; 40 = 8 + 32 reservo el espacio para toooooda la fila



cos_elem0_1: dd 1.0, 1.0, 1.0, 1.0
cos_elem0_2: dd 1.0, 1.0, 1.0, 1.0
cos_elem1_1: dd 0.980785, 0.831470, 0.555570, 0.195090
cos_elem1_2: dd -0.195090, -0.555570, -0.831470, -0.980785
cos_elem2_1: dd 0.923880, 0.382683, -0.382683, -0.923880
cos_elem2_2: dd -0.923880, -0.382683, 0.382683, 0.923880
cos_elem3_1: dd 0.831470, -0.195090, -0.980785, -0.555570
cos_elem3_2: dd 0.555570, 0.980785, 0.195090, -0.831470
cos_elem4_1: dd 0.707107, -0.707107, -0.707107, 0.707107 
cos_elem4_2: dd 0.707107, -0.707107, -0.707107, 0.707107
cos_elem5_1: dd 0.555570, -0.980785, 0.195090, 0.831470
cos_elem5_2: dd -0.831470, -0.195090, 0.980785, -0.555570
cos_elem6_1: dd 0.382683, -0.923880, 0.923880, -0.382683
cos_elem6_2: dd -0.382683, 0.923880, -0.923880, 0.382683
cos_elem7_1: dd 0.195090, -0.555570, 0.831470, -0.980785
cos_elem7_2: dd 0.980785, -0.831470, 0.555570, -0.195090

sqrt_of_eight: dd 2.828427, 1.0, 1.0, 1.0
variable_two: dd 2.0, 1.0, 1.0, 1.0


global dct_c2_asm

section .text

dct_c2_asm:
	push ebp
	mov ebp, esp
	push edi
	push esi
	push ebx
	
	
	mov eax, temp
	mov ebx, i
	mov edi, j
	xor ecx, ecx  ;ecx contiene a
	xor edx, edx

	.caso_elem0:
		xorps xmm1, xmm1
		xorps xmm2, xmm2
		movdqu xmm1, [eax]			; xmm2 tengo los primeros 4 px de temp
		movdqu xmm2, [cos_elem0_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem0_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [y1+y2+y3+y4+x3+x4+x1+x2,0.0, 0.0, 0.0]
		movdqu xmm2, [sqrt_of_eight]; xmm2 = [1.0,1.0,1.0,sqrt(8)]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / sqrt(8)
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 0], xmm1 		; paso a temp el calculo del 1er elemento de la fila

	
		
	.caso_elem1:
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem1_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem1_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 4], xmm1 		; paso a temp el calculo del 1er elemento de la fila
		
	.caso_elem2:
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem2_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem2_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 8], xmm1 		; paso a temp el calculo del 1er elemento de la fila
		
	.caso_elem3:	
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem3_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem3_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 12], xmm1 		; paso a temp el calculo del 1er elemento de la fila
		
	.caso_elem4:
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem4_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem4_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 16], xmm1 		; paso a temp el calculo del 1er elemento de la fila

		
	.caso_elem5:	
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem5_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem5_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 20], xmm1 		; paso a temp el calculo del 1er elemento de la fila

	.caso_elem6:	
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem6_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem6_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 24], xmm1 		; paso a temp el calculo del 1er elemento de la fila

	.caso_elem7:	
		movdqu xmm1, [eax]			; xmm2 = [inicio imagen + (i + k) * witdh *4 + j*4]
		movdqu xmm2, [cos_elem7_1]	
		mulps xmm1, xmm2			
		movdqu xmm3, xmm1			; xmm3 = los primeros 4px con la cuenta del cos listos para sumarse
		movdqu xmm1, [eax + 16] 	; aca ponemos los elementos de la imagen que tenemos que trabajar (imagen[i + a][ j + b])
		;~ cvtdq2ps xmm1, xmm2			; xmm1 = [inicio imagen + (i + k) * witdh *4 + j*4 + 16] en punto flotante de 32b
		movdqu xmm2, [cos_elem7_2] 	
		mulps xmm1, xmm2			; xmm1 = los segundos 4px con la cuenta del cos listos para sumarse
		movdqu xmm2, xmm3			; xmm2 = los primeros 4px con la cuenta del cos listos para sumarse
									; xmm1 = [x1,x2,x3,x4]  xmm2 = [y1,y2,y3,y4]
		haddps xmm1, xmm2			; xmm1 = [y1+y2,y3+y4,x3+x4,x1+x2]
		xorps xmm2, xmm2			; xmm2 = [0.0,0.0,0.0,0.0]
		haddps xmm1, xmm2			; xmm1 = [0.0,0.0,y1+y2+y3+y4,x3+x4+x1+x2]
		haddps xmm1, xmm2			; xmm1 = [0.0, 0.0, 0.0, y1+y2+y3+y4+x3+x4+x1+x2]
		movdqu xmm2, [variable_two]	; xmm2 = [1.0,1.0,1.0,2.0]
		divps xmm1, xmm2			; xmm1 = primer elem calculado / 2
		movdqu xmm2, xmm1
		cvtps2dq xmm1, xmm2
		mov edx, temp2				
		movd [edx + 28], xmm1 		; paso a temp el calculo del 1er elemento de la fila


.fin:	
	pop ebx
	pop esi
	pop edi
	pop ebp
	ret
