#ifndef list_h
#define list_h

#define TAM_STR_C sizeof(nodo_lista_c)-sizeof(nodo_arbol_t *)-sizeof(void*)

#define corre_con_c 0
#define corre_con_asm 1

typedef struct {
        int simbolo;
        unsigned int apariciones;
        unsigned int valido;
        void* padre;
        void* izq;
        void* der;
        } __attribute__ (( __packed__ )) nodo_arbol_t;
       
//~ typedef struct{
        //~ unsigned int caracter;
        //~ unsigned int codigo;
        //~ unsigned int long_cod;
        //~ } __attribute__ (( __packed__ )) codigo_t;


typedef struct{
        int caracter;
        unsigned int codigo;
        unsigned int long_cod;
        nodo_arbol_t * nodo_arbol;
        void* sig;
        } __attribute__ (( __packed__ )) nodo_lista_c;
        
typedef struct{
        nodo_arbol_t * nodo_arbol;
        void* sig;
        } __attribute__ (( __packed__ )) nodo_lista_ab;



nodo_lista_ab * crear_nodo_lista_ab(nodo_arbol_t * nodo_ab, nodo_lista_ab * sig);
nodo_lista_ab * crear_nodo_lista_ab_default();
nodo_lista_ab *  insertar_ordenado_ab (nodo_lista_ab * lista, nodo_arbol_t * nodo_arbol_n);
nodo_lista_ab *  buscar_simbolo_ab (nodo_lista_ab * lista, int simbolo, int * posicion);

void mostrar_lista_ab ( nodo_lista_ab *l );
int long_lista_ab (nodo_lista_ab * lista);
int eliminar_lista_ab ( nodo_lista_ab * l );

nodo_lista_c * crear_nodo_lista(nodo_arbol_t * nodo_ab, unsigned int simbolo, nodo_lista_c * sig);
nodo_lista_c * crear_nodo_lista_default();
nodo_lista_c *  buscar_simbolo (nodo_lista_c * lista, unsigned int simbolo, nodo_lista_c * nodo_ant);

void mostrar_codigos (nodo_lista_c * lista);
unsigned int long_lista_codigos (nodo_lista_c * lista);
int eliminar_lista ( nodo_lista_c * l );

#endif

